# Degree Centrality

In graph theory, centrality is any measure that determines how
structurally important a node is within a graph and the degree of a node
is a count of its neighbours.

Degree Centrality is a measure of a node’s importance determined by the
number of nodes it is connected to (i.e. the degree of the node). The
higher the degree of the node, the more important it is.

## Parameters

-   *Transaction Types* - Calculate on only the subgraph of transactions
    of these types
-   *Include Incoming* - Include incoming connections
-   *Include Outgoing* - Include outgoing connections
-   *Include Undirected* - Treat undirected connections as bidirectional
    connections
-   *Normalise By Max Possible Score* - Normalise calculated scores by
    the maximum possible score
-   *Normalise By Max Available Score* - Normalise calculated scores by
    the maximum calculated score
-   *Selected Only* - Calculate using only selected graph elements
