# Local Clustering Coefficient

In graph theory, a clustering coefficient is a measure of the extent to
which nodes in a graph tend to cluster together and a clique is a group
of nodes whereby each pair of nodes shares a connection (every possible
link exists). A node’s neighbourhood is the induced subgraph of a node
and its neighbours (also known as a 1.5 hop network or an ego network).

The local clustering coefficient of a node is the measure of how close a
node’s neighbourhood is to being a clique. It is the ratio of the number
of relationships that exist in the neighbourhood compared to the number
of relationships that could possibly exist. It is a measure of a node’s
interconnectedness.

## Parameters

-   *Transaction Types* - Calculate on only the subgraph of transactions
    of these types
-   *Normalise By Max Available Score* - Normalise calculated scores by
    the maximum calculated score
