# Notes View

<table class="table table-striped">
<thead>
<tr class="header">
<th>Constellation Action</th>
<th>Keyboard Shortcut</th>
<th>User Action</th>
<th style="text-align: center;">Menu Icon</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td>Open Notes View</td>
<td>Ctrl + Shift + A</td>
<td>Views -&gt; Notes View</td>
<td style="text-align: center;"><img src="../ext/docs/CoreNotesView/src/au/gov/asd/tac/constellation/views/notes/resources/notes-view.png" alt="Notes View Icon" /></td>
</tr>
</tbody>
</table>

## Introduction

The Notes View allows you to annotate on your graph. This is useful for
remembering important pieces of information, and keeping track of what
plugins have been run.

<div style="text-align: center">

<img src="../ext/docs/CoreNotesView/src/au/gov/asd/tac/constellation/views/notes/resources/NotesView.png" alt="Notes
View" />

</div>

There are two kinds of notes that can be added to the Notes View:

## User-Generated Notes

These are notes which are created by a user and are colored purple by default.
These notes are generated by clicking on the "Create Note" button on the top left and
filling the title and note fields located in the pop-up window that appears. Both of these
fields need to be filled in otherwise a message will pop-up prompting
you to fill in both fields. There is a colour picker where the user can pick what colour the note should be. If you have the "Link note to graph
selection" option enabled, the note will be applied to all the nodes and
transactions that are selected on the graph (a count of how many of each
will be displayed on the note). If the option is not enabled, or there
is nothing selected on the graph, the note is applied to the entire
graph. Notes will be a default height and will have a "Show More" button if the contents of the note exceed the height.

Once added, these notes can edited by pressing the "Edit" button on the
note. A note can be deleted by pressing the "Delete" button on the note.

You can see which nodes and transactions a user-generated note is linked
to by right-clicking on a note and pressing "Select on Graph". This will
change the graph selection to only the nodes and transactions linked to
that note. To change the selection linked to the note, make a selection 
on the graph, right-click on the note, and then select either "Add Selected" 
to link all of the selected nodes and transactions to the note or 
"Removed Selected" to unlink any part of the selection already linked to 
the note.

## Auto-Generated Notes

These are notes which are created by Constellation and are colored
blue. These notes are generated when plugins are executed. Unlike user
generated notes, these notes cannot be edited or removed.

NOTE: Auto generated notes are always created in the background but they
won't be added to the Notes View unless the view is open. If you close
Constellation before it has a chance to add those notes to the Notes
View, those notes will be lost.

## Filters

There are filters available to determine what notes are visible in the
view:

-   *User Notes*: Show all the user-generated notes.
-   *Auto Notes*: Show all the auto-generated notes. When this is
    ticked, an additional filter drop-down is added, allowing you to
    filter on specific types of plugins.
-   *Selected*: Show all the user-generated notes for a given selection
    (including those applied to the entire graph). When this is ticked,
    the User Notes and Auto Notes options are automatically unticked (if
    any of them are ticked). Similarly, if you tick one of the other
    filter options, this option will be automatically unticked.
-   *Time range filter*: A time range filter that allows the user to only  
    display notes in a specific time range. Times can be changed to different
    time zones.

## Markdown Support

The Notes View supports some Markdown text now. There is a checkbox in the new note
window that allows you to enable and disable Markdown. Markdown is a markup language
for creating formatted text. As of now the notes view supports Markdown features like:

    1. Headings
        Put the 1-6 # characters and a space before text to create a heading.
        The higher the number os #s the smaller the heading.
    2. Italics
        You can write italic text by surrounding text with (_) or (*). For example _Italic text_ or *Italic text*.
    3. Bold
        You can have bold text by surrounding text with (__) or (**). For example **Bold text** or __Bold text__.
    4. Strikethrough
        You can have Strikethrough text by surrounding text with (~~). For example ~~Strikethrough text~~.
    5. Lists
        You can have ordered lists. Lists must start with "1." and space before the item text then every consequent list item must have a number
        and dot before it to be included in the list. Sublists can also be made, simply make a list item and then in the line under it press tab
        so that indentation is one more than the parent list item and then write (1. ) to start a new list. Every list item with the same indentation
        as the first sublist item will be included as part of the sublist.
        List example
            1. List item 1
            2. List item 2
                1. Sublist item 1
                2. Notice how sublist starts the same way as regular list just indented
                    1. Sub-sub list
            3. List item 3
