/*
 * Copyright 2010-2024 Australian Signals Directorate
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package au.gov.asd.tac.constellation.utilities.timer;

import static org.testng.Assert.assertTrue;
import org.testng.annotations.AfterClass;
import org.testng.annotations.AfterMethod;
import org.testng.annotations.BeforeClass;
import org.testng.annotations.BeforeMethod;
import org.testng.annotations.Test;

/**
 *
 * @author antares
 */
public class TimerNGTest {
    
    public TimerNGTest() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }

    @BeforeMethod
    public void setUpMethod() throws Exception {
    }

    @AfterMethod
    public void tearDownMethod() throws Exception {
    }

    /**
     * Test of start method, of class Timer.
     * @throws java.lang.InterruptedException
     */
    @Test
    public void testTimer() throws InterruptedException {
        System.out.println("timer");
        
        // immediately starting since we're not asserting anything beforehand
        // we can't know for sure exactly what value the start time is set to so we're only going to assert that the time
        // when it's stopped is greater than what is was when we started
        final Timer instance = new Timer().start();
        final long startTime = instance.getStartTime();
        
        instance.stop("Timer Test");
        final long endTime = instance.getStartTime();
        
        assertTrue(endTime > startTime);
    }
}
