<!--

### Requirements

* Filling out the template is required. Any pull request that does not include
enough information to be reviewed in a timely manner may be closed at the
maintainers' discretion.
* Have you read Constellation's Code of Conduct? By filing an issue, you are
expected to comply with it, including treating everyone with respect:
https://github.com/constellation-app/constellation/blob/master/CODE_OF_CONDUCT.md

-->

### Prerequisites

- [ ] Put an X between the brackets on this line if you have done all of
    the following:

    -   Running the latest version of Constellation

    -   Attached the ***Support Package*** via `Help` &gt;
        `Support Package`

    -   Checked the FAQs:
        https://github.com/constellation-app/constellation/wiki/FAQ

    -   Checked that your issue isn’t already filed:
        https://github.com/constellation-app/constellation/issues

    -   Checked that there is not already a module that provides the
        described functionality:
        https://github.com/constellation-app/constellation/wiki/Catalogue-of-Repositories

### Description

\[Description of the issue\]

### Steps to Reproduce

1.  \[First Step\]

2.  \[Second Step\]

3.  \[and so on…\]

<!--

### Behaviour

* Try to include measurable metrics that can be aimed for (if applicable to the issue),
e.g. if it's a time issue then "should take 5 seconds or less to finish"
or if it's a workflow issue "should be accomplished in 2 or less clicks".

-->

**Expected behaviour:** \[What you expect to happen\]

**Actual behaviour:** \[What actually happens\]

**Reproduces how often:** \[What percentage of the time does it reproduce?\]

### Additional Information

Any additional information, configuration or data that might be
necessary to reproduce the issue.
